[Before submitting an issue, please check that your issue hasn't been already
filed]

### Description

[Description of the issue]

### Steps to Reproduce

1. [First Step]
2. [Second Step]
3. [and so on...]

[Provide a minimal, compilable code snippet (either through a
[GitHub gist](https://gist.github.com/) or your own files reproducing the issue
if necessary]

### Expected behavior

[What you expect to happen]

### Actual behavior

[What actually happens]

### Reproducibility

[What percentage of the time does it reproduce?]

### Versions

[If a tagged version, you can get this information by inspecting the
`ITK_VERSION_MAJOR` `ITK_VERSION_MINOR` and `ITK_VERSION_PATCH` variable
values in the `ITKConfig.cmake` file]

[If the commit number is required, run `$ git rev-parse --short HEAD`]

### Environment

[Which your OS and compiler are]

### Additional Information

[Any additional information, configuration or data that might be necessary to reproduce the issue.]


Note: Use issues for their purpose; issues are not for code help. Need help? Ask
your question at [https://discourse.itk.org/](https://discourse.itk.org/)
